function [ liqsat, IFT, Visc, GasComp,LiqComp] = BULK_CVD(NCOMP,T, zi, PMIN, PMAX, NNP,Tc, Pc, w, Parachor, MW, Vc, kijmat, Log)
R = 0.0083144E3; %MPa.cm^3/mol.K
eps=1E-12;
err = 1;
NP = 1;

while NP <= NNP+1
err = 1;
Iter =0;
Pv = PMAX - (PMAX - PMIN)/NNP * (NP - 1);


%IFT [dyne/cm] RPore [m]
Pl= Pv;







%Calculate reduced temperatures and pressures
Tr = T./Tc;
Pr = Pv./Pc;
% R = 8.314472; %MPa.cm^3/mol.K
K= 1./Pr.*exp(5.37.*(1+w).*(1-1./Tr));

while err > eps
    
   if NP==1
   yi=zi; xi= yi./K; nv=1;
   else
[ nv,xi,yi ] = FLASH( zi, K );
   end

[ Zl, Zv, compFugIl, compFugIv,compFugCoIl,compFugCoIv] = PR_EOS(NCOMP,xi,yi, T, Pv,Tc, Pc, w, kijmat);
K=Pl/Pv*compFugCoIl./compFugCoIv ;
err=sqrt(sum((1-compFugIv./compFugIl).^2));
Iter =Iter +1;
% msg = sprintf('%s %1.3f %s %1.3f %s %1.3f %s %1.3f %s %1.3f',...
%     'Pv= ',Pv*145.0377,'Pl', Pl*145.0377,'nv= ',nv,'Zl= ',Zl, 'Zv= ',Zv); disp(msg);
% if Iter > 50,  break, end
end % EOS Error Loop
%%
if NP==1 % Dew Point 
N=Pv/(Zv*R * T);
Vsat = 1; 
end
%%
Vv = Zv *nv*N* R * T / Pv;
Vl = Zl *(1-nv)*N* R * T / Pl;
Vtot=Vl+Vv;
VlRel = Vl/Vsat;

%%
Vremoved = Vtot-1;
Nv = nv*N;
Nl = (1-nv)*N;
Nremoved = Pv*Vremoved /(Zv*R*T);
Nremain = Nv-Nremoved ;
N=Nl + Nremain;
zi = (xi* Nl + yi* Nremain) /(Nl + Nremain);
%%
if Log ==1
msg = sprintf('%s %1.3f %s %1.3f %s %1.3f %s %1.3f %s %1.3f',...
    'Pv= ',Pv*145.0377,'Pl', Pl*145.0377,'nv= ',nv,'Vl= ',Vl, 'Vv= ',Vv, 'Vsat', Vsat,'N', N, 'Nre', Nremain); disp(msg),
end
%% IFT
IFT(NP)= IFT_Fun( Parachor, Pl, Pv , Zl, Zv,T, xi, yi );
%% Visco
MolDensIq= Pl/(Zl*R*T);
MolDensVa= Pv/(Zv*R*T);
[ ViscoL, ViscoV ] = Visco( xi, yi, Tc, Pc, Vc, MW, MolDensIq, MolDensVa , Tr, Pr);
Visc(NP,1)= Pv;
Visc(NP,2)= ViscoV;
Visc(NP,3)= ViscoL;
%%
liqsat(NP, 1)= Pv ;
liqsat(NP, 2)= VlRel;
liqsat(NP, 3)= Zv;
liqsat(NP, 4)= sum(MW .* yi);

for o=1:NCOMP
    GasComp(NP, o)= yi(o);
    LiqComp(NP, o)= xi(o);
end
  
  
NP = NP +1;

end % Pressure Step Loop
end


