function [ DP, IFT] = CAP_DEWPOINT(NCOMP,T, zi, PMAX,Tc, Pc, w, Parachor, MW,Vc,kijmat, CosTheta,RPore, IFT, Log)

% RPore nm
% OBJ: FLASH CALCULATION 
eps=1E-12;

DP = PMAX;


Iter=0;

err = 1;
%Calculate reduced temperatures and pressures
Tr = T./Tc;
Pr = DP./Pc;

yi=zi;

K=1./Pr.*exp(5.37.*(1+w).*(1-1./Tr));

while err > eps

xi= yi./K; 

Pl = DP-2* CosTheta * (IFT) / (RPore*1E-9)* 1E-9 ; Pcap = DP -Pl;

[ Zl, Zv, compFugIl, compFugIv,compFugCoIl,compFugCoIv] = CAP_PR_EOS(NCOMP,xi,yi, T, Pl, DP,Tc, Pc, w,kijmat);

err=sum((1-compFugIv./compFugIl).^2);

K=compFugCoIl./compFugCoIv * Pl/DP ;
DPnew = DP * sum(yi./K);
   
DP=DPnew ;
IFT= IFT_Fun( Parachor, Pl, DP , Zl, Zv,T, xi, yi );
%%
if Log ==1
msg = sprintf('%s %1.3f %s %1.3f %s %1.3f %s %1.3f %s %1.3f',...
'T', T,'DP= ',DP*145.0377,'Pl', Pl*145.0377,'err= ',err) ;disp(msg);
end
%%
Iter =Iter +1;
end % EOS Error Loop


end


