function [ DP, IFT] = DEWPOINT(NCOMP,T, zi, PMAX,Tc, Pc, w, Parachor, MW,Vc,kijmat, Log)

% OBJ: FLASH CALCULATION 
eps=1E-12;
DP = PMAX;
Iter=0;
err = 1;
%Calculate reduced temperatures and pressures
Tr = T./Tc;
Pr = DP./Pc;

yi=zi;

K=1./Pr.*exp(5.37.*(1+w).*(1-1./Tr));

while err > eps

xi= yi./K; 

[ Zl, Zv, compFugIl, compFugIv,compFugCoIl,compFugCoIv] = PR_EOS(NCOMP,xi,yi, T, DP,Tc, Pc, w, kijmat);
K=compFugCoIl./compFugCoIv ;
DPnew = DP * sum(yi./K);

err= sqrt(sum((1-compFugIv./compFugIl).^2));
   
DP=DPnew ;
%%
if Log ==1
msg = sprintf('%s %1.3f %s %1.3f %s %1.3f %s %1.3f %s %1.3f',...
'T', T,'DP= ',DP*145.0377,'err= ',err); disp(msg);
end
%%
Iter =Iter +1;

end % EOS Error Loop
IFT= IFT_Fun( Parachor, DP, DP , Zl, Zv,T, xi, yi );
end


