function GasProp = InputGasProp(PVT_Table)
%INPUTGASPROP Summary of this function goes here
%   Detailed explanation goes here

% 1 Pressure
% 2 ug
% 3 Zg
% 4 Matrix Pseudo-Pressure
% 5 cg gas compressibility
% 6 E factor
% 7 Liquid Dropout
% 8 Krgm(p)
% 9 Krom(p)
% 10 Krgf(p)
% 11 Krof(p)
% 12 Fracture Pseudo-Pressure
% 13 Fp: Fp=Pm/Pf; farction of Pseudo-P matrix over Pseudo-P fracture over
% 14 uo
% 15 zo
% 16 Gas MW (Molecular Wgheit
% 17 Numerical E factor
% 18 IFT
%% INPUT RUNSPEC
[ Runspec ] = Read_Runspec;
ActMFlow = Runspec(1);
% Matrix
km_int = Runspec(2); %Intrensic Permeability, mD
Phim = Runspec(3); % matrix porosity
Tau=Runspec(4);
crockm= Runspec(5);
L = Runspec(6); % ft
% Fracture
kf = Runspec(7);% Fracture Permeability 
Phif= Runspec(8);%Fracture Porosity
crockf = Runspec(9);% psi-1
% Reservoir-Completion
h= Runspec(10);%, ft, Reservoir Thikness
xF = Runspec(11);
Yl=Runspec(12); %, ft 
Tres= Runspec(13);% R = 90 C
pi=Runspec(14);
%SCAL
Krgmax=Runspec(15);
Kromax=Runspec(16);
ng=Runspec(17);
no=Runspec(18);
Sgr=Runspec(19);
Soc =Runspec(20);






[ GasProp, N ] = ReadGasPVTwithIFT( PVT_Table );

[N, M]= size(GasProp);



%% Rel. Perm Matrix

for i=1:N
    
%    if GasProp(i,7) <= Sgr
%        GasProp(i,8) =Krgmax;
%        GasProp(i,9) =0;
%    else 
%        GasProp(i,8) =Krgmax * (((1-GasProp(i,7))-Sgr)/(1-Sgr-Soc))^ng ;
       GasProp(i,8) = Krgmax * (  (1-GasProp(i,7)  -Sgr)/(1-Sgr))^ng;
       GasProp(i,9) =Kromax * ((GasProp(i,7)-Sgr)/(1-Sgr-Soc))^no ;
%    end
   

% [ GasProp(i,8), GasProp(i,9) ] = RelPERM_JAIL2( Krgmax, Kromax, ng, no, Sgr, Soc, 1-GasProp(i,7) );

end

%% Rel. Perm Fracture
GasProp(:,10)= 1-GasProp(:,7); % Krgf(p)
GasProp(:,11)= GasProp(:,7); %Krof(p)

%% Fracture Pseudo-Pressure
GasProp(:,12)=zeros(N,1);
for i=2:N
    % m(p) = 2* { P E Krg / u Z dp
GasProp(i,12) = GasProp(i-1,12)+ 2* GasProp(i,1)*GasProp(i,10)/(GasProp(i,2)*GasProp(i,3))*(GasProp(i,1) - GasProp(i-1,1));
end


%% Gas Compressibility cg =1/p-1/z * dz/dp
GasProp(:,5)=zeros(N,1);
for i=2:N
GasProp(i,5) = 1/GasProp(i,1)-1/GasProp(i,3) *   1/2   *   (       (GasProp(i,3) - GasProp(i-1,3))/(GasProp(i,1) - GasProp(i-1,1))   +   (GasProp(i,3) - GasProp(i-1,3))/(GasProp(i,1) - GasProp(i-1,1))        );
end


%% Print GasProp
dlmwrite('GasFile.txt',GasProp,'delimiter', '\t');
end
