function [ PERM, QRate,u_avg, Iter, Rel_ERR] = Solver_Liq( GasProp,Dim,CONN,R, POIS_FACT, psitoPa, T, Rg,Tolerance, KN, PDim,INDEX, P, Pmid, DimX, Tho, Pinlet,Poutlet,Alpha0, A, B)
% Equation System Solver

m2tonDarcy = 1.013249966e+21;
for i=1:Dim^3
    for j=1:Dim^3
Pavg(i,j)=(P(i,1)+P(j,1))/2 ; % psi
    end
end

Rel_ERR =1;
Iter =1;
 while Rel_ERR > Tolerance  
%% u & Z 
 for i=1:Dim^3
    for j=1:Dim^3
if CONN(i,j) ~=0
[u(i,j), Z(i,j), MW(i,j) ] = Find_mu_Z_Lig( Pavg(i,j)/psitoPa, GasProp );
else u(i,j) =0;Z(i,j) =0; MW(i,j)=0;
end
    end
 end
%% G_Darcy = POIS_Fact/u
for i=1:Dim^3
    for j=1:Dim^3
if CONN(i,j) ~=0
G_Darcy(i,j) = POIS_FACT(i,j)/u(i,j); %m3/cp
else G_Darcy(i,j) =0;
end
    end
end
%% E
%C_lamda = u Z sqrt[pi R T /2MW]
C = u.*Z.*sqrt(pi* Rg* T ./(2*MW));
 for i=1:Dim^3
    for j=1:Dim^3
if CONN(i,j) ~=0
    
 if KN ==1 || KN ==2 %1: Knudsen condensate 2 Knudsen dry gas 

E(i,j) = E_Func( R(i,j), T, MW(i,j),  Pavg(i,j)/psitoPa, u(i,j) , Z(i,j), Alpha0, A, B );
 else
     E(i,j) =1;
 end
else E(i,j) =0;
end
    end
 end
%% G = E * G_Darcy 
G = E .* G_Darcy; 

%% %%%%%%%%%%%%%%%%%%%%%
% M ... M X -Const = 0
%%%%%%%%%%%%%%%%%%%%%%%%
 for k=1:PDim
     for l=1:PDim
         i= INDEX(k,2);
         j= INDEX(l,2);
         
         if k==l
            M(k,l)= sum(G(i,1:Dim^3));
         else
            M(k,l)= -G(i,j);
         end
     end
 end
 %% Constant
 for k=1:PDim
       i= INDEX(k,2);

     Const(k)= sum(G(i,1:Dim^2).*P(1:Dim^2)')+ sum(G(i,Dim^3-Dim^2+1:Dim^3).*P(Dim^3-Dim^2+1:Dim^3)');
 end
 %% J
 %%%%%%%%%%%%%%%%%%%%
 
 % du_dP 
  for i=1:Dim^3
    for j=1:Dim^3
du_dP(i,j)=0 ;
    end
end
 % dZ_dP 
   for i=1:Dim^3
    for j=1:Dim^3
dZ_dP(i,j)=0 ;
    end
   end

% dG_Darcy_dP
dG_Darcy_dP = POIS_FACT.* du_dP./u.^2;
   
% dC_dP
 dC_dP = (du_dP+dZ_dP )*sqrt(pi* Rg* T ./(2*MW));
dE_dP=zeros(Dim^3,Dim^3);

% dG_dP
dG_dP = dE_dP .* G_Darcy + dG_Darcy_dP .* E;

for i=1:Dim^3
    for j=1:Dim^3
if R(i,j) ~=0
dG_dP(i,j) = dE_dP (i,j)* G_Darcy(i,j) + dG_Darcy_dP(i,j)* E(i,j);
else dG_dP(i,j) =0;
end
    end
end

% dP_dPi =  dP_dPj  = 1/2
% Pavg = (Pi+Pj) / 2 
%dG_dPi = dG_dP * dP_dPi = 1/2 dG_dP
dG_dPj = 1/2 * dG_dP;

%dM_dPj
for k=1:PDim
     for l=1:PDim
         
         i= INDEX(k,2);
         j= INDEX(l,2);
         
         if k==l
            dM_dPj(k,l)= sum(dG_dPj(i,:));
         else
            dM_dPj(k,l)= -dG_dPj(i,j);
         end
     end
 end

for i=1:PDim
    for j=1:PDim
J(i,j)= dM_dPj(i,:)*Pmid(:) + M(i,j);
    end
end
Jinv = inv(J);

R_FUN = M*Pmid -Const';
MeanR = mean(abs(R_FUN));

for k=1:PDim
i= INDEX(k,2);
P(i,1)=Pmid(k);
end

for i=1:Dim^3
    for j=1:Dim^3
Q(i,j) = G(i,j)* (P(i)-P(j)); %m3/s
% VEL(i,j) = Q(i,j)* (pi/4*R(i,j)^2);
    end
end

% Qinlet
Qinlet =sum( sum ( abs (Q(Dim^2+1:Dim^3,1:Dim^2))));
% Qoutlet 
Qoutlet =sum( sum ( abs(Q(1:Dim^3-Dim^2,Dim^3-Dim^2+1:Dim^3))));
% QRate
QRate= (Qinlet + Qoutlet)/2;

ERR_RATE_RATIO = (Qinlet - Qoutlet)/Qinlet;
Rel_ERR = sqrt(sum(R_FUN.^2))/((Qinlet+Qoutlet)/2);

if Rel_ERR > Tolerance
Pmid= Pmid - Jinv * R_FUN;
end

if Iter >20
         Rel_ERR=0;
end

Iter = Iter+1;
 end % iteration
 % u_average
u_avg = mean(mean(~u));
 % Permeability
% Q= A K dP/u L
PERM = QRate * DimX * u_avg /((Pinlet -Poutlet)* DimX^2) / Tho*m2tonDarcy;

end

