function [ ViscoL, ViscoV ] = Visco( xi, yi, Tc, Pc, Vc, MW, RhoL, RhoV , Tr, Pr)
%UNTITLED Summary of this function goes here
%   Detailed explanation goes here

a1 = 0.1023000;
a2 = 0.0233640;
a3 = 0.0585330;
a4 = -0.0407580;
a5 = 0.0093324;

Pc=9.86923267*Pc; %% from MPa to atm;
% Vc=1E-3*Vc;
%%__________________________________________

ei=Tc.^(1/6)./(MW.^0.5 .* Pc.^(2/3));


for i=1:2
    
    if Tr(i)<1.5
        visco_atmi = 34E-5*Tr(i)^0.94/ei(i);
        
    else
       visco_atmi = (17.78E-5*(4.58*Tr(i)-1.67)^0.625)/ei(i);
      
    end
end


%% Liquid ____________________________-
emixL= sum(xi.*Tc)^(1/6)/(sum(xi.*MW)^0.5*sum(xi.*Pc)^(2/3));

visco_atmL= sum(xi.*visco_atmi.*MW.^0.5)/sum(xi.*MW.^0.5);

RhoLr=RhoL/(sum(xi.*Vc))^(-1);% reduced liquid density

ViscoL=visco_atmL +1/emixL*((a1 + a2*RhoLr + a3*RhoLr^2 + a4*RhoLr^3 + a5*RhoLr^4)^4-1E-4);


%% Gas _______________________________________________________________

emixV= sum(yi.*Tc)^(1/6)/(sum(yi.*MW)^0.5*sum(yi.*Pc)^(2/3));

visco_atmV= sum(yi.*visco_atmi.*MW.^0.5)/sum(yi.*MW.^0.5);

RhoVr=RhoV/(sum(yi.*Vc))^(-1);% reduced Vapour density

ViscoV=visco_atmV +((a1 + a2*RhoVr + a3*RhoVr^2 + a4*RhoVr^3 + a5*RhoVr^4)^4-1E-4) /emixV;

end

